// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SceneItemComponent.hpp"
#include "SceneItem.hpp"
#include "Scene.hpp"
#include "game/DawnGame.hpp"

using namespace Dawn;

SceneItemComponent::SceneItemComponent(std::weak_ptr<SceneItem> item) {
  this->item = item;
}

std::shared_ptr<Scene> SceneItemComponent::getScene() {
  return this->item.lock()->scene.lock();
}

std::shared_ptr<DawnGame> SceneItemComponent::getGame() {
  return this->item.lock()->scene.lock()->game.lock();
}

SceneItemComponent::~SceneItemComponent() {

}