// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "dawnlibs.hpp"

namespace Dawn {
  class SceneItem;
  class Scene;
  class DawnGame;

  class SceneItemComponent {
    public:
      std::weak_ptr<SceneItem> item;

      SceneItemComponent(std::weak_ptr<SceneItem> item);
      
      virtual void start() = 0;

      std::shared_ptr<Scene> getScene();
      std::shared_ptr<DawnGame> getGame();

      virtual ~SceneItemComponent();
  };
}