// Copyright (c) 2022 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "dawnopengl.hpp"
#include "game/DawnGame.hpp"
#include "display/RenderManager.hpp"
#include "display/BackBufferRenderTarget.hpp"

using namespace Dawn;

RenderManager::RenderManager(std::weak_ptr<DawnGame> game) {
  this->game = game;
  this->renderTarget=std::make_shared<BackBufferRenderTarget>(weak_from_this());
}

void RenderManager::init() {
}

std::shared_ptr<RenderTarget> RenderManager::getBackBuffer() {
  return this->renderTarget;
}

void RenderManager::update() {
  this->getBackBuffer()->bind();
  this->getBackBuffer()->clear(
    RENDER_TARGET_CLEAR_FLAG_COLOR |
    RENDER_TARGET_CLEAR_FLAG_DEPTH
  );
}

RenderManager::~RenderManager() {

}